/* ===========================================================================
                           TTB Plugin Template(VC++)

                                 Main.cpp

   =========================================================================== */
#include "Windows.h"

#include "Main.h"
#include "MessageDef.h"

#define COMMAND_LIST_FIRST 1
#define COMMAND_LIST_LAST  100

HINSTANCE g_hInstance;

// --------------------------------------------------------
//    init@C擾
// --------------------------------------------------------
inline LPSTR GetIniFileName(LPSTR lpFileName, UINT uLen = MAX_PATH)
{
	DWORD dwSize;
	dwSize = GetModuleFileName(g_hInstance, lpFileName, uLen - 1);
	lpFileName[dwSize - 3] = 'i';
	lpFileName[dwSize - 2] = 'n';
	lpFileName[dwSize - 1] = 'i';

	return lpFileName;
}

BOOL ExecuteCommand(const char* iniFileName, const char* sectionName, int id)
{
	BOOL ret = FALSE;
	char *buf = NULL, keyName[8];
	DWORD size = 1024, retsize;

	//INIt@Cf[^擾
	itoa(id, keyName, 10);
	buf = (char *)malloc(size);
	retsize = ::GetPrivateProfileString(sectionName, keyName, "", buf, size, iniFileName);
	while (retsize - 1 == size) {
		size += 1024;
		buf = (char *)realloc(buf, size);
		retsize = ::GetPrivateProfileString(sectionName, keyName, "", buf, size, iniFileName);
	}

	if (strlen(buf) > 0) {
		//擾f[^|ŕ
		char *tok, *dllName = NULL, *sCmdId = NULL;
		int cmdId = 0;
		ret = ((tok = strtok(buf, "|")) != NULL);
		if (ret) dllName = tok;
		ret = (ret && (tok = strtok(NULL, "|")) != NULL);
		if (ret) sCmdId = tok;
		if (sCmdId != NULL) {
			cmdId = atoi(sCmdId);
		}

		//R}hs
		ExecutePluginCommand(dllName, cmdId);
	}

	free(buf);

	return ret;
}

// --------------------------------------------------------
//    vOC[hꂽƂɌĂ΂
// --------------------------------------------------------
BOOL Init(void)
{
	char iniFileName[MAX_PATH];

	GetIniFileName(iniFileName);

	for (int i = COMMAND_LIST_FIRST; i <= COMMAND_LIST_LAST; i++) {
		ExecuteCommand(iniFileName, "Startup", i);
	}

	return TRUE;
}

// --------------------------------------------------------
//    vOCA[hꂽƂɌĂ΂
// --------------------------------------------------------
void Unload(void)
{
	char iniFileName[MAX_PATH];

	GetIniFileName(iniFileName);

	for (int i = COMMAND_LIST_FIRST; i <= COMMAND_LIST_LAST; i++) {
		ExecuteCommand(iniFileName, "Shutdown", i);
	}
}

// --------------------------------------------------------
//    R}hsɌĂ΂
// --------------------------------------------------------
BOOL Execute(int CmdId, HWND hWnd)
{
	return TRUE;
}

// --------------------------------------------------------
//    O[otbNbZ[WĂ
// --------------------------------------------------------
void Hook(UINT Msg, DWORD wParam, DWORD lParam)
{
}


// --------------------------------------------------------
//    DLLMain
// --------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}
#endif

#if _MSC_VER > 1000
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
		g_hInstance = hInstance;
	return TRUE;
}
#endif

